#include <stdlib.h>
#include <stdio.h>

#include "DistributeVecLib.h"

int main(int argc, char **argv) {

    FILE *fp; 
    char filename[MAX_WORD_LENGTH]; 
    long P, P1, n, n1, j, j1, s1;
    int *owner;

    printf("Test WriteVectorDistribution: ");
    P = 5;  /* number of  processors >= 1 */
    n = 100; /* length of the owner array */

    owner = (int *)malloc(n*sizeof(int));

    if (owner == NULL){
        printf("Error\n");
        exit(1);
    }

    /* Initialise owners */
    for (j=0; j<n; j++) 
        owner[j]= (j+1)%P;

    /* Write the distribution to file */
    strcpy(filename,"outWriteVectorDistribution");
    
    fp = fopen(filename, "w");
    WriteVectorDistribution(owner, n, P, fp);
    fclose(fp);

    /* Read the values back and check whether they are OK */
    fp = fopen(filename, "r");
    
    if (!fp) {
        printf("Error\n");
        exit(1);
    }
    
    if (fscanf(fp,"%ld %ld",&n1,&P1) != 2) {
        printf("Error\n");
        exit(1);
    }
    
    if (n1 != n || P1 != P) {
        printf("Error\n");
        exit(1);
    }

    for (j=0; j<n; j++){ 
        if (fscanf(fp,"%ld %ld",&j1,&s1) != 2) {
            printf("Error\n");
            exit(1);
        }
        /* Values read from file are 1-based */
        if (j1 != j+1 || s1 != ((j+1)%P) + 1) {
            printf("Error\n"); 
            exit(1); 
        } 
    }
    
    fclose(fp);

    printf("OK\n");
    exit(0);

} /* end main */
